scala.tools.nsc.Global

# genASM

###
Related Doc: package Global

#### object genASM extends GenASM

Source
  Global.scala

Linear Supertypes
GenASM, BytecodeWriters, SubComponent, AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. genASM
2. GenASM
3. BytecodeWriters
4. SubComponent
5. AnyRef
6. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class AsmPhase extends Global.icodes.ICodePhase

   JVM code generation phase

   JVM code generation phase

   Definition Classes
     GenASM

2. #### trait AsmpBytecodeWriter extends BytecodeWriter

   Definition Classes
     BytecodeWriters

3. #### case class BlockInteval(start: Global.icodes.BasicBlock, end: Global.icodes.BasicBlock) extends Product with Serializable

   Definition Classes
     GenASM

4. #### trait BytecodeWriter extends AnyRef

   Definition Classes
     BytecodeWriters

5. #### class CClassWriter extends ClassWriter

   Definition Classes
     GenASM

6. #### trait ClassBytecodeWriter extends BytecodeWriter

   Definition Classes
     BytecodeWriters

7. #### class DirectToJarfileWriter extends BytecodeWriter

   Definition Classes
     BytecodeWriters

8. #### trait DumpBytecodeWriter extends BytecodeWriter

   Definition Classes
     BytecodeWriters

9. #### trait JAndroidBuilder extends AnyRef

   Definition Classes
     GenASM

10. #### class JBeanInfoBuilder extends JBuilder

    builder of bean info classes

    builder of bean info classes

    Definition Classes
      GenASM

11. #### abstract class JBuilder extends AnyRef

    basic functionality for class file building

    basic functionality for class file building

    Definition Classes
      GenASM

12. #### abstract class JCommonBuilder extends JBuilder

    functionality for building plain and mirror classes

    functionality for building plain and mirror classes

    Definition Classes
      GenASM

13. #### class JMirrorBuilder extends JCommonBuilder

    builder of mirror classes

    builder of mirror classes

    Definition Classes
      GenASM

14. #### class JPlainBuilder extends JCommonBuilder with JAndroidBuilder

    builder of plain classes

    builder of plain classes

    Definition Classes
      GenASM

15. #### case class MethodNameAndType(mname: String, mdesc: String) extends Product with Serializable

    Definition Classes
      GenASM

16. #### abstract class StdPhase extends GlobalPhase

    A standard phase template

    A standard phase template

    Definition Classes
      SubComponent

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### val JAVA_LANG_OBJECT: asm.Type

   Definition Classes
     GenASM

5. #### val JAVA_LANG_STRING: asm.Type

   Definition Classes
     GenASM

6. #### final val MaximumJvmParameters: Int(254)

   Definition Classes
     GenASM

7. #### final def afterOwnPhase[T](op: ⇒ T): T

   Definition Classes
     SubComponent
   Annotations
     @inline()

8. #### final def arrEncode(sb: Global.ScalaSigBytes): Array[String]

   Definition Classes
     GenASM

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### val bCodeAsmCommon: BCodeAsmCommon[global.type]

    Definition Classes
      GenASM

11. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def factoryNonJarBytecodeWriter(): BytecodeWriter

    Definition Classes
      BytecodeWriters

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def getCommonSuperClass(inameA: String, inameB: String): String

    Definition Classes
      GenASM

20. #### def getFile(sym: Global.Symbol, clsName: String, suffix: String): AbstractFile

    Definition Classes
      BytecodeWriters

21. #### def getFile(base: AbstractFile, clsName: String, suffix: String): AbstractFile

    clsName

      cls.getName

    Definition Classes
      BytecodeWriters

22. #### def getGenericSignature(sym: Global.Symbol, owner: Global.Symbol, memberTpe: Global.Type, unit: Global.CompilationUnit): String

    Definition Classes
      GenASM

23. #### def getGenericSignature(sym: Global.Symbol, owner: Global.Symbol, unit: Global.CompilationUnit): String

    returns

      - `null` if no Java signature is to be added (`null` is what ASM expects in these cases).
      - otherwise the signature in question
    Definition Classes
      GenASM

24. #### val global: Global.this.type

    The global environment; overridden by instantiation in Global.

    The global environment; overridden by instantiation in Global.

    Definition Classes
      genASM → BytecodeWriters → SubComponent

25. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    returns

      the hash code value for this object.

    Definition Classes
      SubComponent → AnyRef → Any

26. #### def inameToSymbol(iname: String): Global.Symbol

    Given an internal name (eg "java/lang/Integer") returns the class symbol for it.

    Given an internal name (eg "java/lang/Integer") returns the class symbol for it.

    Better not to need this method (an example where control flow arrives here is welcome). This method is invoked only upon both (1) and (2) below happening: (1) providing an asm.ClassWriter with an internal name by other means than javaName() (2) forgetting to track the corresponding class-symbol in reverseJavaName.

    (The first item is already unlikely because we rely on javaName() to do the bookkeeping for entries that should go in innerClassBuffer.)

    (We could do completely without this method at the expense of computing stack-map-frames ourselves and invoking visitFrame(), but that would require another pass over all instructions.)

    Right now I can't think of any invocation of visitSomething() on MethodVisitor where we hand an internal name not backed by a reverseJavaName. However, I'm leaving this note just in case any such oversight is discovered.

    Definition Classes
      GenASM

27. #### val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent

28. #### val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent

29. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

30. #### def isNonUnitValueTK(tk: icodes.TypeKind): Boolean

    Definition Classes
      GenASM

31. #### def isStaticModule(sym: Global.Symbol): Boolean

    Definition Classes
      GenASM

32. #### def isTopLevelModule(sym: Global.Symbol): Boolean

    Definition Classes
      GenASM

33. #### def javaFieldFlags(sym: Global.Symbol): Int

    Definition Classes
      GenASM

34. #### def javaFlags(sym: Global.Symbol): Int

    Return the Java modifiers for the given symbol.

    Return the Java modifiers for the given symbol. Java modifiers for classes:

    - public, abstract, final, strictfp (not used) for interfaces:
    - the same as for classes, without 'final' for fields:
    - public, private (*)
    - static, final for methods:
    - the same as for fields, plus:
    - abstract, synchronized (not used), strictfp (not used), native (not used)

    (*) protected cannot be used, since inner classes 'see' protected members, and they would fail verification after lifted.

    Definition Classes
      GenASM

35. #### val javaNameCache: AnyRefMap[Global.Symbol, Global.Name]

    Definition Classes
      GenASM

36. #### def jsymbol(sym: Global.Symbol): Global.Symbol

    Definition Classes
      GenASM

37. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

38. #### object newNormal

    A namespace for utilities to normalize the code of an IMethod, over and beyond what IMethod.normalize() strives for.

    A namespace for utilities to normalize the code of an IMethod, over and beyond what IMethod.normalize() strives for. In particular, IMethod.normalize() doesn't collapseJumpChains().

    TODO Eventually, these utilities should be moved to IMethod and reused from normalize() (there's nothing JVM-specific about them).

    Definition Classes
      GenASM

39. #### def newPhase(p: Phase): Phase

    Create a new phase

    Create a new phase

    Definition Classes
      GenASM → SubComponent

40. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

42. #### def outputDirectory(sym: Global.Symbol): AbstractFile

    Definition Classes
      BytecodeWriters

43. #### def ownPhase: Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

44. #### val phaseName: String

    The name of the phase

    The name of the phase

    Definition Classes
      GenASM → SubComponent

45. #### def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent

46. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

47. #### var pickledBytes: Int

    Definition Classes
      GenASM

48. #### val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent

49. #### val reverseJavaName: AnyRefMap[String, Global.Symbol]

    Definition Classes
      GenASM

50. #### val runsAfter: collection.immutable.List[String]

    Names of phases that must run before this phase.

    Names of phases that must run before this phase.

    Definition Classes
      genASM → SubComponent

51. #### val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent

52. #### val runsRightAfter: None.type

    Name of the phase that this phase must follow immediately.

    Name of the phase that this phase must follow immediately.

    Definition Classes
      genASM → SubComponent

53. #### final def staticForwarderGenericSignature(sym: Global.Symbol, moduleClass: Global.Symbol, unit: Global.CompilationUnit): String

    Definition Classes
      GenASM

54. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

55. #### val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent

56. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

57. #### def ubytesToCharArray(bytes: Array[Byte]): Array[Char]

    Definition Classes
      GenASM

58. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

59. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

60. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from GenASM

### Inherited from BytecodeWriters

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Ungrouped